.nr O 1
.nr v 5
.\"     @(#)sloargs.3	1.13 (Pixar) 12/22/96
.\"
.\"---------------------------------------------------------------------
.\"                 Copyright (c) 1989 Pixar
.\"
.\"   These coded statements,  instructions,  computer programs, and
.\"   listings are protected by Federal copyright law and are not to
.\"   be disclosed to unauthorized  persons without the written con-
.\"   sent of Pixar.
.\"---------------------------------------------------------------------
.\"
.if '\nO'0' .nr O 1
.if '\nO'1' .TH SLO_GETSHADER 3 "12/22/96" "Release 3.\nv" "\fIPhotoRealistic RenderMan\fP (\s-1UNIX\s0)"
.if '\nO'2' .TH SLO_GETSHADER 3 "12/22/96" "Release 3.\nv" "\fIPhotoRealistic RenderMan\fP (\s-1MS-DOS\s0)"
.if '\nO'3' .TH SLO_GETSHADER 3 "12/22/96" "Release 3.\nv" "\fIPhotoRealistic RenderMan\fP (\s-1Macintosh\s0)"
.SH NAME
Slo_SetPath,
.if '\nO'3' \{Slo_SetGlobalPath, Slo_SetCurrentPath,
Slo_SetHandlePath, Slo_SetDirIDPath, Slo_ClearPaths, Slo_GetGlobalDirID,
Slo_GetGlobalPathHandle, Slo_GetShaderList, Slo_GetGlobalShaderList,\}
Slo_SetShader, Slo_EndShader, Slo_GetName,
Slo_GetType, Slo_GetNArgs, Slo_GetArgById, Slo_GetArgByName,
Slo_GetArrayArgElement,
.if '\nO'3' Slo_ReleaseCode,
Slo_TypetoStr, Slo_StortoStr, Slo_DetailtoStr
\- get shader information from object file
.SH SYNOPSIS
.nf
.ft B
#include <slo.h>
.PP
.ft B
Slo_SetPath(path)
char *path;
.if '\nO'3' \{.PP
.ft B
OSErr Slo_SetGlobalPath()
.PP
.ft B
OSErr Slo_SetCurrentPath(recur)
Boolean recur;
.PP
.ft B
OSErr Slo_SetHandlePath(h, recur);
Handle h;
Boolean recur;
.PP
.ft B
OSErr Slo_SetDirIDPath(vRef, dirID, recur);
short vRef;
long dirID;
Boolean recur;
.PP
.ft B
int Slo_ClearPaths()
.PP
.ft B
OSErr Slo_GetGlobalDirID(vRef, dirID, recur);
short *vRef;
long *dirID;
Boolean *recur;
.PP
.ft B
OSErr Slo_GetGlobalPathHandle(h, recur);
Handle *h;
Boolean *recur;
.PP
.ft B
OSErr Slo_GetShaderList(vRef, dirID, recur, h);
short vRef;
long dirID;
Boolean recur;
Handle *h;
.PP
.ft B
OSErr Slo_GetGlobalShaderList(h);
Handle *h;\}
.PP
.ft B
int Slo_SetShader(name)
char *name;
.PP
.ft B
char *Slo_GetName()
.PP
.ft B
SLO_TYPE Slo_GetType()
.PP
.ft B
int Slo_GetNArgs()
.PP
.ft B
SLO_VISSYMDEF *Slo_GetArgById(id)
int id;
.PP
.ft B
SLO_VISSYMDEF *Slo_GetArgByName(name)
char *name;
.PP
.ft B
SLO_VISSYMDEF *Slo_GetArrayArgElement(array, index)
SLO_VISSYMDEF *array;
int index;
.PP
.ft B
Slo_EndShader()
.if '\nO'3' \{.PP
.ft B
Slo_ReleaseCode()\}
.PP
.ft B
char *Slo_TypetoStr(type)
SLO_TYPE type;
.PP
.ft B
char *Slo_StortoStr(storage)
SLO_STORAGE storage;
.PP
.ft B
char *Slo_DetailtoStr(detail)
SLO_DETAIL detail;
.SH DESCRIPTION
.I Slo_SetPath
.ie '\nO'3' \{prepends the folder specified by the supplied path
to the list of folders searched when looking for a shader.
The path supplied in the \fIpath\fP parameter is a null-terminated
(C style) string.
If the supplied path string ends in a pair of colons, subfolders
within the specified folder will be searched recursively.\}
.el \{sets the colon-delimited search path used
to locate compiled shaders.
The routine returns 0 on success, -1 with errno set if unable to do so.\}
.if '\nO'3' \{.PP
.I Slo_SetGlobalPath
prepends the Global Shaders and Textures folder
(as specified with RenderManager) to the list
of folders which are searched when looking for a shader.
.PP
.I Slo_SetCurrentPath
prepends the current folder to the list
of folders which are searched when looking for a shader.
If
.I recurFlag
is true, the current folder will be searched recursively.
.PP
.I Slo_ClearPaths
clears the list of folders to be searched when looking for shaders,
freeing all memory associated with them.
This routine can be called to rebuild the list of folders.
.PP
.I Slo_SetHandlePath
prepends the folder specified by the supplied path to the list
of folders which are searched to locate compiled shaders.
The path supplied in the
.I h
parameter is a Macintosh handle containing a
null-terminated (C style) string.
The
.I recur
parameter specifies whether subfolders within the specified
folder should be searched recursively when looking for shaders.
The routine returns
.I noErr
if successful, or a Macintosh error code if an error occurs.
.PP
.I Slo_SetDirIDPath
prepends the folder specified by the
.I vRef
and
.I dirID
parameters to
the list of folders which are searched to locate compiled shaders.
The
.I recur
parameter specifies whether subfolders within the specified folder should be
searched recursively when looking for shaders.
The routine returns
.I noErr
if successful, or a Macintosh error code if an error occurs.
.PP
.I Slo_GetGlobalDirID
returns, in the
.I vRef
and
.I dirID
parameters, the location of the Global Shaders and Textures folder.
This folder is always searched by the renderer when looking
for shaders and textures, after looking in all other specified locations.
The Boolean value returned in the
.I recur
parameter specifies whether the subfolders in this folder are
searched recursively when looking for shaders and textures.
The routine returns
.I noErr
if successful, or a Macintosh error code if an error occurs.
.PP
.I Slo_GetGlobalPathHandle
returns, in the
.I h
parameter, a Macintosh handle containing
the full path of the Global Shaders and Textures folder.
The Boolean value returned in the
.I recur
parameter specifies whether the subfolders in this folder are searched
recursively when looking for shaders and textures.
It is the caller's responsibility
to dispose of the returned handle when the storage is no longer needed.
The routine returns
.I noErr
if successful, or a Macintosh error code if an error occurs.
.PP
.I Slo_GetShaderList
searches the folder specified by the
.I vRef
and
.I dirID
parameters for compiled shaders, making a list of the shaders it finds.
The
.I recur
parameter specifies whether the routine should recursively
search subfolders within the specified
folder when looking for shaders to add to the list.
The list of shaders, consisting
of a Macintosh handle, is returned in the
.I h
parameter.
The format of this handle
is identical to that of a Macintosh string list resource (a STR# resource.)
That is, it contains a two-byte count value followed by the
number of pascal strings indicated by the count value.
It is the caller's responsibility to dispose of the returned
handle when the storage is no longer needed.
The routine returns
.I noErr
if successful, or a Macintosh error code if an error occurs.
.PP
.I Slo_GetGlobalShaderList
searches the current Global Shaders and Textures folder for
compiled shaders, making a list of the shaders it finds.
The list of shaders,consisting of a Macintosh handle, is returned in the
.I h
parameter.
The format of this handle is identical to that of a Macintosh
string list resource (a STR# resource.)
That is, it contains a two-byte count value followed by the number of pascal
strings indicated by the count value.
It is the caller's responsibility to dispose of the
returned handle when the storage is no longer needed.
The routine returns
.I noErr
if successful, or a Macintosh error code if an error occurs.\}
.PP
.I Slo_SetShader
attempts to locate and read the specified shader (in compiled format)
using the
.ie '\nO'3' current list of folders to be searched.
.el same search path used by the renderer.
It returns 0 if successful making the specified shader the
.I current
shader.
It returns -1 on error with the global variable
.I errno
set to indicate the error condition.
.PP
.I Slo_GetName
returns a pointer to a null terminated ascii string
containing the name of the current shader.
(This storage for the string name is freed when a new shader
is made current or
.I Slo_EndShader
is executed.)
.PP
.I Slo_GetType
returns the type of the current shader, where type is one of
the following:
.RS
.PP
.nf
    SLO_TYPE_SURFACE		surface shader
    SLO_TYPE_LIGHT			light shader
    SLO_TYPE_VOLUME			volume shader
    SLO_TYPE_DISPLACEMENT		displacement shader
    SLO_TYPE_TRANSFORMATION	transformation shader
    SLO_TYPE_IMAGER			imager shader
.ad
.fi
.RE
.PP
.I Slo_GetNArgs
returns the number of arguments accepted by the current shader.
.PP
.IR Slo_GetArgByName ,
and
.I Slo_GetArgById
each return a pointer to an object with the
following structure
containing the
.I visible
fields of a shader symbol definition:
.RS
.PP
.nf
typedef struct slovissymdef {
	char		*svd_name;	/* name of symbol */
	SLO_TYPE	svd_type;	/* symbol type */
	SLO_STORAGE	svd_storage;	/* symbol storage class */
	SLO_DETAIL	svd_detail;	/* symbol variance */
	char		*svd_spacename;	/* name of space in which */
					/* to interpret symbol's value */
	int		svd_arraylen;	/* #elements in array symbol */
	union {
		POINT	*pointval;	/* pointers to default value */
		SCALAR	*scalarval;
		char	*stringval;
		float   *matrixval;
	} svd_default;
} SLO_VISSYMDEF;
.ft R
.ad
.fi
.RE
.PP
The members of this structure are:
.TP \w'svd_spacename'u+2n
svd_name
The ascii symbol name
.TP \w'svd_spacename'u+2n
svd_type
The
.I type
of the symbol where
.I type
is one of the following:
.RS
.PP
.nf
    SLO_TYPE_POINT		three floating point values
    SLO_TYPE_VECTOR		three floating point values
    SLO_TYPE_NORMAL		three floating point values
    SLO_TYPE_COLOR		three floating point values
    SLO_TYPE_SCALAR		one floating point value
    SLO_TYPE_STRING		null-terminated ascii string
    SLO_TYPE_MATRIX		sixteen floating point values
.ad
.fi
.RE
.TP \w'svd_spacename'u+2n
svd_storage
The storage class of the symbol; currently either:
.RS
.PP
.nf
    SLO_STOR_PARAMETER          symbol is a standard read-only parameter
    SLO_STOR_OUTPUTPARAMETER    symbol is an output parameter
.ad
.fi
.RE
.TP \w'svd_spacename'u+2n
svd_detail
The breadth of the symbol; currently either:
.RS
.PP
.nf
    SLO_DETAIL_VARYING	symbol's value varies over a geometric primitive
    SLO_DETAIL_UNIFORM	symbol's value is constant over a geometric primitive
.ad
.fi
.RE
.TP \w'svd_spacename'u+2n
svd_spacename
An ascii string specifying the
.I space
the variable is to be evaluated in.
(This only has meaning for geometric and color variables, and is the
NULL string "" for variables of type SLO_TYPE_SCALAR and SLO_TYPE_STRING).
.TP \w'svd_spacename'u+2n
svd_arraylen
For a variable which is a Shading Language array, this member contains
an integer which specifies how many elements are in the array.
For such a variable, the
.I svd_default
is never valid, and instead
.I Slo_GetArrayArgElement
is used to access individual element default values.
This member is 0 for any variable which is not an array.
.TP \w'svd_spacename'u+2n
svd_default
A pointer (typed) to its default value if the parameter has one.
.PP
The storage for this structure is static and must be copied
elsewhere if its value is to be retained across calls.
.I Slo_GetArgByName
returns a pointer to a symbol definition based on the
.I name
parameter.
.I Slo_GetArgById
uses the argument
.I id
where
.I id
is an integer between 1 and the value returned by
.I Slo_GetNArgs
inclusive.
.PP
.I Slo_GetArrayArgElement
returns a SLOVISSYMDEF structure for a single element of an array.
It takes as arguments the SLOVISSYMDEF pointer of the array variable,
and an
.I index
into the array, which is an integer between 0 and \fI
.if \n(.k+\w'array->svd_arraylen \(mi\ 1'>\n(.l .br
array->svd_arraylen\ \(mi\ 1\fP.
.PP
.I Slo_EndShader
releases the storage used internally for the shader definition.
.if '\nO'3' \{.PP
.I Slo_ReleaseCode
releases the code resource which contains the
.I SloArgs
code,
allowing the memory it occupies to be reused by the application.
This routine can be called as often as necessary,
since calling any of the
.I SloArgs
routines will reload the code if necessary.\}
.PP
.IR Slo_TypetoStr ,
.IR Slo_StortoStr ,
and
.I Slo_DetailtoStr
return ascii representations of
SLO_TYPE, SLO_STORAGE, and SLO_DETAIL
values respectively.
.SH FILES
.if '\nO'3' \{
SloArgs.CODE	 - stand-alone code resources containing most of the \fISloArgs\fP code.
.br
saclinet.c	 - source files containing code which loads and executes
the routines in the \fISloArgs\fP code resources.
.br
saslo.c	 - header file containing definitions of the \fISloArgs\fP routines.\}
.fi\}
.if '\nO'2' \{.nf
\\rman\\shaders	 - standard shader definitions.
\\rman\\src\\sloargs - sloargs source
.fi\}
.if '\nO'1' \{.nf
/data_anim/rmanrels/p37.2.MIPS2/reyes/lib/shaders	 - standard shader definitions.
/data_anim/rmanrels/p37.2.MIPS2/reyes/lib/libsloargs.a	 - sloargs library
.fi\}
.SH DIAGNOSTICS
Null pointer
(0) returned by
.I Slo_GetArgByName()
and
.I Slo_GetArgById()
on error.
.SH BUGS
All information
is contained in a static area
so it must be copied if it is
to be saved.
.xx
